Attribute VB_Name = "jcam_dll"
Option Explicit
' Signed 8 bit integer.
'typedef signed char         INT8;
' Signed 16 bit integer.
'typedef signed short        INT16;
' Signed 32 bit integer.
'typedef signed int          INT32;
' Unsigned 8 bit integer.
'typedef unsigned char       UINT8;
' Unsigned 16 bit integer.
'typedef unsigned short      UINT16;
' Unsigned 32 bit integer.
'typedef unsigned int        UINT32;

' \brief Constants that avoid the traditional problems of \c \#define constants.
'enum jsConstants
'{
'       OPERATION_FAILURE   = 21,
'       SCANNER_FAILURE     = -1,
'       INVALID_PARAMETER   = -2,
'       PROFILE_UNAVAILABLE = -3,
'       SOCKET_TIMEOUT      = -4,
'       SYNC_MODE_OVERRUN = 0x00000001,
'       MAX_HORIZONTAL = 324,
'       MAX_VERTICAL   = 243,
'       IPS_STATIC    = 0,
'       IPS_BY_ID     = 1,
'       IPS_BY_DHCP   = 2,
'       STATUS_NORMAL = 0,
'       STATUS_ACTIVE = 1,
'       OPTIONS_SIZE  = 512,
'};

' \brief An operation was unable to complete.
Public Const OPERATION_FAILURE = 21
' \brief The connection to the scanner is invalid.
Public Const SCANNER_FAILURE = -1
' \brief A parameter to a function was \c NULL or out of range.
Public Const INVALID_PARAMETER = -2
' \brief A scanner in Synchronized Scanning Mode has no available profiles.
Public Const PROFILE_UNAVAILABLE = -3
' \brief A connection to a scanner timed out.
Public Const SOCKET_TIMEOUT = -4
' \brief If this bit is set in a \c #jsProfile's flags field, then Synchronized Scanning Mode is running the scanner too fast.
Public Const SYNC_MODE_OVERRUN = 1
' \brief CCD sensor dimensions.
Public Const MAX_HORIZONTAL = 324
' \brief CCD sensor dimensions.
Public Const MAX_VERTICAL = 243
Public Const IMAGE_SIZE = 78732

' \brief Static IP Address for a scanner.
Public Const IPS_STATIC = 0
' \brief IP Address is determined by the cable ID.
Public Const IPS_BY_ID = 1
' \brief IP Address is assigned with DHCP.
Public Const IPS_BY_DHCP = 2
' \brief The scanner is fine.
Public Const STATUS_NORMAL = 0
' \brief The scanner is scanning.
Public Const STATUS_ACTIVE = 1
' \brief The number of bytes in a \c #jsResponsePacket's \c options field.
Public Const OPTIONS_SIZE = 512

' If an invalid laser is specified, the connection will be closed.
'typedef enum jsLaserIndexTag
'{
'       LASER0 = 0,
'       LASER1 = 1,
'		LASER2 = 2,
'} jsLaserIndex;

'  \brief Furthest from the camera.
Public Const LASER0 = 0
'  \brief Closer to the camera than LASER0
Public Const LASER1 = 1
'  \brief Closer to the camera than LASER1
Public Const LASER2 = 2
' \brief An opaque handle for connections to scanners.
' \c #JCONNECTION's are full-duplex request/reply connections.
' Functions have been provided that handle all the request/reply semantics.
'typedef void * JCONNECTION;

'#pragma pack(1) 'Tells compiler to use one-byte boundaries for packing structs.
'typedef struct tagProfileDataPoint
'{
'       INT32 x;
'       INT32 y;
'       INT32 brightness;
'} ProfileDataPoint;

' \brief Represents a coordinate and its associated pixel brightness.
Type ProfileDataPoint
'  \brief The x coordinate of the data point in 1000ths of an inch.
    x As Long

' \brief The y coordinate of the data point in 1000ths of an inch.
    y As Long
' \brief The intensity of the pixel where the laser was detected.
' The value is the sum of 7 pixels, each with 10 bits of resolution.
' Consequently, the maximum value is 7  2<SUP>10</SUP> = 7168.
' If you want to display this value in a traditional 255 level greyscale, you will have to map the brightness value to a 255 level greyscale on your own.
   brightness As Long
End Type

' \brief Represents a subpixel point from a scanner and its brightness.
'typedef struct tagScanDataPoint
'{
'       INT32 data;
'       INT32 status;
'       INT32 brightness;
'} ScanDataPoint;

' \brief Represents a subpixel point from a scanner and its brightness.
Type ScanDataPoint
' \brief Which subpixel the laser was centered at.
' Range is from 0 to 32,400 because there are 100 subpixels per pixel and 324 pixels.
    data As Long
' \brief A simple representation of the intensity of the pixel.
' 0 means invalid.<br>
' 1 means normal.<br>
' 2 means bright.<br>
' 3 means very bright.
    status As Long
' \brief The actual intensity of the pixel where the laser was detected.
' The value is the sum of 7 pixels, each with 10 bits of resolution.
' Consequently, the maximum value is 7  2<SUP>10</SUP> = 7168.
' If you want to display this value in a traditional 255 level greyscale.
' you will have to map the brightness value to a 255 level greyscale on your own.
    brightness As Long
End Type

'typedef struct tagProfile
'{
'       INT32 sequenceNumber;
'       INT32 location;
'       INT32 sendLocation;
'       INT32 laserOnTime;
'       INT32 timeInHead;
'       INT32 inputs;
'       INT32 flags;
'       INT32 laserIndex;
'       INT32 reserved2;
'       INT32 numberPoints;
'       ProfileDataPoint data[MAX_VERTICAL];
'} jsProfile;

' \brief Profile data from the scanner.
Type jsProfile
' \brief Sequence number from Synchronized Scanning Mode.
' Sequential \c #jsProfile's during Synchronized Scanning Mode should have sequential \c sequenceNumber's.
' The counter is reset to 0 every time Synchronized Scanning Mode is restarted.
    sequenceNumber As Long
' \brief The encoder value when when the scanner created the profile.
    location As Long
' \brief The encoder value when the scanner sent the profile.
    sendLocation As Long
' \brief The number of microseconds the laser was on.
    laserOnTime As Long
' \brief The time since the scanner was turned on.
' It is not the time of day, nor the current date.
    timeInHead As Long
' \brief The cable input to the scanner.
' This includes the Cable ID, the encoder signals, and the Start Scan signal.
    inputs As Long
' \brief Information from the scanner.
' If bit 0 is set, then Synchronized Scanning Mode scanning is trying to run faster than the scanner is capable.
' The rest of the bits are unused and should be 0.
    flags As Long
' \brief Currently unused.
    laserIndex As Long
' \brief Currently unused.
    reserved2 As Long
' \brief The number of valid coordinate points in this profile.
    numberPoints As Long
' \brief Coordinates in 1000ths of an inch; i.e. 2000 is 2 inches.
' \c #MAX_VERTICAL is defined in \c #jsConstants.
    data(MAX_VERTICAL - 1) As ProfileDataPoint
End Type

'typedef struct tagProfileLarge
'{
'       INT32 sequenceNumber;
'       INT32 location;
'       INT32 sendLocation;
'       INT32 laserOnTime;
'       INT32 timeInHead;
'       INT32 inputs;
'       INT32 flags;
'       INT32 reserved1;
'       INT32 reserved2;
'       INT32 numberPoints;
'       ProfileDataPoint data[MAX_VERTICAL*2];
'} jsProfileLarge;

' \brief Profile data from the scanner.
Type jsProfileLarge
' \brief Sequence number from Synchronized Scanning Mode.
' Sequential \c #jsProfile's during Synchronized Scanning Mode should have sequential \c sequenceNumber's.
' The counter is reset to 0 every time Synchronized Scanning Mode is restarted.
    sequenceNumber As Long
' \brief The encoder value when when the scanner created the profile.
    location As Long
' \brief The encoder value when the scanner sent the profile.
    sendLocation As Long
' \brief The number of microseconds the laser was on.
    laserOnTime As Long
' \brief The time since the scanner was turned on.
' It is not the time of day, nor the current date.
    timeInHead As Long
' \brief The cable input to the scanner.
' This includes the Cable ID, the encoder signals, and the Start Scan signal.
    inputs As Long
' \brief Information from the scanner.
' If bit 0 is set, then Synchronized Scanning Mode scanning is trying to run faster than the scanner is capable.
' The rest of the bits are unused and should be 0.
    flags As Long
' \brief Currently unused.
    reserved1 As Long
' \brief Currently unused.
    reserved2 As Long
' \brief The number of valid coordinate points in this profile.
    numberPoints As Long
' \brief Coordinates in 1000ths of an inch; i.e. 2000 is 2 inches.
' \c #MAX_VERTICAL is defined in \c #jsConstants.
    data((MAX_VERTICAL*2) - 1) As ProfileDataPoint
End Type

'typedef struct tagScan
'{
'       INT32 location;
'       INT32 sendLocation;
'       INT32 laserOnTime;
'       INT32 timeInHead;
'       INT32 inputs;
'       INT32 flags;
'       INT32 reserved1;
'       INT32 reserved2;
'       INT32 numberPoints;
'       ScanDataPoint data[MAX_VERTICAL];
'} jsScan;

' \brief Scan data from the scanner.
Type jsScan
' \brief The encoder value when the scan was taken.
    location As Long
' \brief The encoder value when the scan was sent.
    sendLocation As Long
' \brief The number of microseconds the laser was on.
    laserOnTime As Long
' \brief The time since the scanner was turned on.
' It is not the time of day, nor the current date.
    timeInHead As Long
' \brief The cable input to the scanner.
' This includes the Cable ID, the encoder signals, and the Start Scan signal.
    inputs As Long
' \brief Information from the scanner.
' If bit 0 is set, then Synchronized Scanning Mode scanning is trying to run faster than the scanner is capable.
' The rest of the bits are unused and should be 0.
    flags As Long
' \brief Currently unused.
    reserved1 As Long
' \brief Currently unused.
    reserved2 As Long
' \brief The number of valid pixel points in this profile.
    numberPoints As Long
' \brief Pixel data points.
' \c #MAX_VERTICAL is defined in \c #jsConstants.
    data(MAX_VERTICAL - 1) As ScanDataPoint
End Type

'typedef struct tagImage
'{
'       INT32 exposureTime;
'       INT32 reserved1;
'       INT32 reserved2;
'       INT32 numberHorizontal;
'       INT32 numberVertical;
'       UINT8 image[MAX_HORIZONTAL * MAX_VERTICAL];
'} jsImage;

' \brief Image data from the scanner.
'Type jsImage
' \brief How many microseconds the camera was exposed.
'    exposureTime As Long
' \brief Currently unused.
'    reserved1 As Long
' \brief Currently unused.
'    reserved2 As Long
' \brief The number of horizontal pixels.
'    numberHorizontal As Long
' \brief The number of vertical pixels.
'    numberVertical As Long
' \brief The image pixels.
' \c #MAX_VERTICAL and \c #MAX_HORIZONTAL are defined in \c #jsConstants.
'    image(IMAGE_SIZE - 1) As Byte
'End Type

'typedef struct tagResponsePacket
'{
'  		UINT8  macAddress[6];
'       UINT8  currentIpSetup;
'       UINT32 ipAddress;
'       UINT32 serialNumber;
'       UINT8  cableId;
'       UINT8  status;
'       UINT32 build;
'       INT8   options[OPTIONS_SIZE];
'} jsResponsePacket;

' \brief Responses from scanners on the network.
Type jsResponsePacket
' \brief The Ethernet hardware MAC address of the scanner.
    macAddress(0 to 5) As Byte
' \brief The current addressing technique the scanner is using.
' \c #IPS_STATIC Static IP Address for the scanner.<br>
' \c #IPS_BY_ID IP Address is determined by the cable ID.<br>
' \c #IPS_BY_DHCP IP Address is assigned with DHCP.
    currentIpSetup As Byte
' \brief The IP Address of the responding scanner, in <B>network byte order</B>.
    ipAddress As Long
' \brief The serial number of the responding scanner.
    serialNumber As Long
' \brief The cable ID of the responding scanner.
    cableId As Byte
' \brief The status of the responding scanner.
    status As Byte
' \brief The firmware revision number of the responding scanner.
    build As Long
' \brief Internal use.  Don't change the contents.
' \c #OPTIONS_SIZE is defined in \c #jsConstants.
    options(OPTIONS_SIZE - 1) As Byte
End Type

'#pragma pack() 'Use compiler default packing after this.
' \ingroup miscellaneousFunctions
' \brief Returns the major revision number of the DLL.
'JCAM_DLL_API int STDCALL jsGetJcamDllMajorVersionNumber();
Declare Function jsGetJcamDllMajorVersionNumber Lib "jcam_dll.dll" () As Long

' \ingroup miscellaneousFunctions
' \brief Returns the minor revision number of the DLL.
'JCAM_DLL_API int STDCALL jsGetJcamDllMinorVersionNumber();
Declare Function jsGetJcamDllMinorVersionNumber Lib "jcam_dll.dll" () As Long

' \ingroup managingConnections
' \brief Opens a connection to the specified host.
' \b All successful calls to this function \b must be closed with a call to jsCloseConnection().
' \param host Can be in either xxx.xxx.xxx.xxx format or can be a DNS name for lookup.
' \return The \c #JCONNECTION on success.
' \return \c NULL if a failure occurred.
'JCAM_DLL_API JCONNECTION STDCALL jsOpenConnection(char const * const host);
Declare Function jsOpenConnection Lib "jcam_dll.dll" (ByVal host As String) As Long

' \ingroup managingConnections
' \brief Opens a connection to the specified host.
' \b All successful calls to this function \b must be closed with a call to jsCloseConnection().
' \param host <b>Must be in network byte order.</b> The best way to get this is by using the \ref scannerDiscovery "Scanner Discovery" functions.
' \return The \c #JCONNECTION on success.
' \return \c NULL if a failure occurred.
'JCAM_DLL_API JCONNECTION STDCALL jsOpenConnectionInt(int const host);
Declare Function jsOpenConnectionInt Lib "jcam_dll.dll" (ByVal host As Long) As Long

' \ingroup managingConnections
' \brief Opens a connection to the specified scanner using Base IP + Cable ID addressing.
'
' \b All successful calls to this function \b must be closed with a call to \c jsCloseConnection().
'
' \param host Can be in either xxx.xxx.xxx.xxx format or can be a DNS name for lookup.
'
' \return The \c #JCONNECTION on success.
' \return \c NULL if a failure occurred.
'JCAM_DLL_API JCONNECTION STDCALL jsOpenConnectionBase(char const * const host, UINT32 const cableID);
Declare Function jsOpenConnectionBase Lib "jcam_dll.dll" (ByVal host As String, ByVal cableID As Long) As Long

' \ingroup managingConnections
' \brief Closes a \c #JCONNECTION.
' It is safe to pass in \c NULL.
' If a function returns \c #SCANNER_FAILURE, you must close the
' connection with this function.  \c #JCONNECTION's are allocated data
' structures that must be properly deallocated, otherwise there will be
' memory leaks in your program.
' \param jc The connection to be closed.
' \return 0 on success.
' \return -1 on all failures.
'JCAM_DLL_API int STDCALL jsCloseConnection(JCONNECTION const jc);
Declare Function jsCloseConnection Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Requests and reads a profile from the default laser.
' May be called while the scanner is or is not in Synchronized Scanning Mode.<br>
' \param jc The connection to read a profile from.
' \param profile Where the profile is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c profile is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #PROFILE_UNAVAILABLE if the scanner is in Synchronized Scanning Mode and there is no profile available.
''JCAM_DLL_API int STDCALL jsGetProfile(JCONNECTION const jc, jsProfile * const profile);
Declare Function jsGetProfile Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profile As jsProfile) As Long

' \ingroup laserSpecific
' \brief Requests and reads a profile from the specified laser.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' \param jc The connection to read a profile from.
' \param laserIndex Which laser to use for the scan.
' \param profile Where the profile is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c profile is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetProfileN(JCONNECTION const jc, jsLaserIndex const laserIndex, jsProfile * const profile);
Declare Function jsGetProfileN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long, ByRef profile As jsProfile) As Long

' \ingroup laserSpecific
' \brief Sends a request for a profile from the specified laser.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' Nothing is read from the connection during this call.
' \param jc The connection to send the request to.
' \param laserIndex  Which laser to use for the scan.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsSendProfileRequestN(JCONNECTION const jc, jsLaserIndex const laserIndex);
Declare Function jsSendProfileRequestN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long) As Long

' \ingroup laserSpecific
' \brief Reads a profile from the connection.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' A call to jsSendProfileRequestN() must have been made to the specified
' \c #JCONNECTION before this function is called.  Otherwise the call will
' block and eventually time out waiting for a profile that isn't coming.
' \param jc The connection to read the profile from.
' \param profile Where the profile is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c profile is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsReadProfileN(JCONNECTION const jc, jsProfile * const profile);
Declare Function jsReadProfileN Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profile As jsProfile) As Long

' \ingroup laserSpecific
' \brief Requests and reads a profile from each laser the scanner has.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' If \c cProfiles indicates \c profiles doesn't have enough space, then extra profiles are discarded.
' Really, \c profiles should point to an array with enough space for a profile from every laser.
' \param jc The connection to read the profiles from.
' \param profiles Pointer to an array of \c #jsProfile's.
' \param cProfiles The number of \c #jsProfile's that \c profiles points to.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c profile is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'TODO pass profiles as an array
'JCAM_DLL_API int STDCALL jsGetProfileFromAllLasers(JCONNECTION const jc, jsProfile * const profiles, size_t const cProfiles);
Declare Function jsGetProfileFromAllLasers Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profile As jsProfile, ByVal cProfiles As Long) As Long

' \ingroup scanAndImage
' \brief Requests and reads an image.
' \param jc The connection to read the image from.
' \param image Where the image is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c image is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetImage(JCONNECTION const jc, jsImage * const image);
'TODO Can't use jsImage...it's too big
'Declare Function jsGetImage Lib "jcam_dll.dll" (ByVal jc As Long, ByRef image As jsImage) As Long

' \ingroup laserSpecific
' \brief Requests and reads an image with the specified laser on.
' \param jc The connection to read the image from.
' \param laserIndex Which laser to use for the image.
' \param image Where the image is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c image is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetImageN(JCONNECTION const jc, jsLaserIndex const laserIndex, jsImage * const image);
'TODO Can't use jsImage...it's too big
'Declare Function jsGetImageN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long, ByRef image As jsImage) As Long

' \ingroup scanAndImage
' \brief Requests and reads a scan.
' \param jc The connection to read the scan from.
' \param scan Where the scan is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c scan is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetScan(JCONNECTION const jc, jsScan * const scan);
Declare Function jsGetScan Lib "jcam_dll.dll" (ByVal jc As Long, ByRef scan As jsScan) As Long

' \ingroup laserSpecific
' \brief Requests and reads a scan with the specified laser on.
' \param jc The connection to read the scan from.
' \param laserIndex Which laser to use for the scan.
' \param scan Where the scan is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c scan is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetScanN(JCONNECTION const jc, jsLaserIndex const laserIndex, jsScan * const scan);
Declare Function jsGetScanN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long, ByRef scan As jsScan) As Long

' \ingroup scanAndImage
' \brief Requests and reads an image and scan.
' \param jc The connection to read the image and scan from.
' \param image Where the image is stored.
' \param scan Where the scan is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c scan is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetImageScan(JCONNECTION const jc, jsImage * const image, jsScan * const scan);
'TODO Can't use jsImage...it's too big
'Declare Function jsGetImageScan Lib "jcam_dll.dll" (ByVal jc As Long, ByRef image As jsImage, ByRef scan As jsScan) As Long

' \ingroup laserSpecific
' \brief Requests and reads an image and scan with the specified laser on.
' \param jc The connection to read the image and scan from.
' \param laserIndex Which laser to use for the image and scan.
' \param image Where the image is stored.
' \param scan Where the scan is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c scan is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetImageScanN(JCONNECTION const jc, jsLaserIndex const laserIndex, jsImage * const image, jsScan * const scan);
'TODO Can't use jsImage...it's too big
'Declare Function jsGetImageScanN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long, ByRef image As jsImage, ByRef scan As jsScan) As Long

' \ingroup laserSpecific
' \brief Requests and reads a scan with the specified camera and laser timings.
' \param jc The connection to read the scan from.
' \param cameraExposure The time in microseconds to expose the camera.
' \param laserExposure The time in microseconds to expose the laser.
' \param scan Where the scan is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c scan is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetDiagnosticScan(JCONNECTION Const jc, int Const cameraExposure, int Const laserExposure, jsImage * Const image, jsScan * Const scan);
Declare Function jsGetDiagnosticScan Lib "jcam_dll.dll" (ByVal jc As Long, ByVal cameraExposure As Long, ByVal laserExposure As Long, ByRef scan As jsScan) As Long

' \ingroup laserSpecific
' \brief Requests and reads an image and scan with the specified camera and laser timings.
' \param jc The connection to read the image and scan from.
' \param cameraExposure The time in microseconds to expose the camera.
' \param laserExposure The time in microseconds to expose the laser.
' \param image Where the image is stored.
' \param scan Where the scan is stored.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c image or \c scan is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsGetDiagnosticImageScan(JCONNECTION const jc, int const cameraExposure, int const laserExposure, jsImage * const image, jsScan * const scan);
'TODO Can't use jsImage...it's too big
'Declare Function jsGetDiagnosticImageScan Lib "jcam_dll.dll" (ByVal jc As Long, ByVal cameraExposure As Long, ByVal laserExposure As Long, ByRef image As jsImage, ByRef scan As jsScan) As Long

' \ingroup synchronizedScanning
' \brief Sets the scanner's internal encoder value.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' \param jc The connection to the scanner.
' \param newEncoderValue The new encoder value for the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsSetEncoderValue(JCONNECTION const jc, UINT16 newEncoderValue);
Declare Function jsSetEncoderValue Lib "jcam_dll.dll" (ByVal jc As Long, ByVal newEncoderValue As Integer) As Long

' \ingroup synchronizedScanning
' \brief Sets the scanner's internal encoder value.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' \param jc The connection to the scanner.
' \param newEncoderValue The new encoder value for the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsSetEncoderValue(JCONNECTION const jc, UINT32 newEncoderValue);
Declare Function jsSetEncoderValue32 Lib "jcam_dll.dll" (ByVal jc As Long, ByVal newEncoderValue As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to enter Start Scan Triggered Synchronized Scanning Mode.
' While in Start Scan Triggered Synchronized Scanning Mode, the scanners will trigger on the appropriate edge of the Start Scan signal, depending on the presence of \c StartScanTriggerOnHigh.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' \see \c #jsExitSyncMode()
' \param jc The connection to the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsEnterStartScanTriggeredMode(JCONNECTION const jc);
Declare Function jsEnterPulseSyncMode Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to enter Encoder Synchronized Scanning Mode.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' \param jc The connection to the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsEnterEncoderSyncMode(JCONNECTION const jc);
Declare Function jsEnterEncoderSyncMode Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to enter Time Synchronized Scanning Mode.
' May \b not be called while the scanner is in Synchronized Scanning Mode.<br>
' \param jc The connection to the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsEnterTimeSyncMode(JCONNECTION const jc);
Declare Function jsEnterTimeSyncMode Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to ouput a pulse train on the Start Scan I/O.  The period and number of pulses are configurable
' 
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
' 
' \see \c #jsStopPulses()
' 
' \param jc The connection to the scanner.
' \param pulseInterval The period in microseconds of the pulse train. Between 1,000 and 5,000,000.
' \param pulseCount The number of pulses to send before stopping.  If zero pulses will be continuously sent.  Max value is 511.
'
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL, or other parameters are out of range.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsStartPulseMaster(JCONNECTION const jc, int pulseInterval, int pulseCount);
Declare Function jsStartPulseMaster Lib "jcam_dll.dll" (ByVal jc As Long, ByVal pulseInverval As Long, ByVal pulseCount As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to stop generating a pulse train on the Start Scan I/O.
'
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
'
' \see \c #jsStartPulseMaster()
'
' \param jc The connection to the scanner.
' 
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsStopPulses(JCONNECTION const jc);
Declare Function jsStopPulses Lib "jcam_dll.dll" (ByVal jc As Long) As Long


' \ingroup synchronizedScanning
' \brief Set the alternating exposure parameters.  Only works in sync mode.  Settings are lost when exiting sync mode and must be resent after re-entering syncmode.
'
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
'
' \param jc The connection to the scanner.
' \param enable If true enable the alternating exposure mode, if false return to normal exposure mode.
' \param exposure1 One of the two exposure times, must be between 10 and 650000.
' \param exposure2 One of the two exposure times, must be between 10 and 650000
'
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL, or other parameters are out of range.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsSetAlternatingExposure(JCONNECTION const jc, bool const enable, int const exposure1, int const exposure2);
Declare Function jsSetAlternatingExposure Lib "jcam_dll.dll" (ByVal jc As Long, ByVal enable As Boolean, ByVal exposure1 As Long, ByVal exposure2 As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to halt Time or Encoder Synchronized Scanning Mode.
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
' Any scans queued up in the scanner can still be read using jsGetProfile().
' The scanner is still in Synchronized Scanning Mode after calling this function.
' A call to jsExitSyncMode() must follow in order to exit Synchronized Scanning Mode.
' \param jc The connection to the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsHaltSyncMode(JCONNECTION const jc);
Declare Function jsHaltSyncMode Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Causes the scanner to exit Time or Encoder Synchronized Scanning Mode.
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
' Any queued scans will be lost.
' \param jc The connection to the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsExitSyncMode(JCONNECTION const jc);
Declare Function jsExitSyncMode Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Requests and reads up to n profiles from the scanner while in either Synchronized Scanning Mode.
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
' If the parameters attempt to run the scanner faster than it can physically scan,
' then bit 0 in the flags field of the jsProfile's will be set.
' \param jc The connection to the scanner.
' \param profiles Pointer to an array of \c #jsProfile's.
' \param cProfiles The number of \c #jsProfile's that \c profiles points to.  Also how many profiles are requested from the scanner.
' \return The number of valid profiles on success.
' \return 0 if no profiles are available.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #INVALID_PARAMETER if \c jc or \c profiles is \c NULL.
'TODO pass profiles as an array
'JCAM_DLL_API int STDCALL jsGetMultipleProfiles(JCONNECTION const jc, jsProfile * const profiles, UINT32 const cProfiles);
Declare Function jsGetMultipleProfiles Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profiles As jsProfile, ByVal cProfiles As Long) As Long

' \ingroup synchronizedScanning
' \brief Sends a request for up to \c n profiles to the scanner while in Synchronized Scanning Mode.
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
' No profiles are read from the connection during this call.
' In order to read the profiles, a call to jsReadMultipleProfiles() must follow.
' If the parameters attempt to run the scanner faster than it can physically scan,
' then bit 0 in the flags field of the jsProfile's will be set.
' \param jc The connection to the scanner.
' \param n The number of profiles to request from the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsSendMultipleProfileRequest(JCONNECTION const jc, UINT32 const n);
Declare Function jsSendMultipleProfileRequest Lib "jcam_dll.dll" (ByVal jc As Long, ByVal n As Long) As Long

' \ingroup synchronizedScanning
' \brief Reads up to \c cProfiles profiles from jc after a
' jsSendMultipleProfileRequest() call in Synchronized Scanning Mode.
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
' \c cProfiles should be equal or greater than the number of profiles
' requested in the corresponding call to jsSendMultipleProfileRequest().
' If \c cProfiles is smaller than thenumber of profiles requested,
' any extra profiles will be read from the scanner and discarded.
' If the parameters attempt to run the scanner faster than it can physically scan,
' then bit 0 in the flags field of the jsProfile's will be set.
' \param jc The connection to the scanner.
' \param profiles Pointer to an array of \c #jsProfile's.
' \param cProfiles The number of \c #jsProfile's \c profiles points to.
' \return The number of valid profiles on success.
' \return 0 if no profiles are available.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #INVALID_PARAMETER if \c jc or \c profiles is \c NULL.
'JCAM_DLL_API int STDCALL jsReadMultipleProfiles(JCONNECTION const jc, jsProfile * const profiles, UINT32 cProfiles);
Declare Function jsReadMultipleProfiles Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profile As jsProfile, ByVal cProfiles As Long) As Long

'JCAM_DLL_API int STDCALL jsReadMultipleLargeProfiles(JCONNECTION const jc, jsProfileLarge * const profiles, UINT32 const nProfilesRequested, long timeoutMilliseconds);
Declare Function jsReadMultipleLargeProfiles Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profile As jsProfileLarge, ByVal cProfiles As Long, ByVal timeoutMilliseconds As Long) As Long

' \ingroup synchronizedScanning
' \brief Requests and reads up to n profiles from the scanner while in either Synchronized Scanning Mode.
'
' May \b only be called while the scanner is in Synchronized Scanning Mode.<br>
'
' If the parameters attempt to run the scanner faster than it can physically scan,
' then bit 0 in the flags field of the \c #jsProfile's will be set.
'
' \param jc The connection to the scanner.
' \param profiles Pointer to an array of \c #jsProfile's.
' \param cProfiles The number of \c #jsProfile's that \c profiles points to.  Also how many profiles are requested from the scanner.
' \param timeoutMilliseconds The maximum number of milliseconds that a read is allowed to take.
'
' \return The number of valid profiles on success.
' \return 0 if no profiles are available.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #INVALID_PARAMETER if \c jc or \c profiles is \c NULL.
' \return \c #SOCKET_TIMEOUT if the read took longer than the specified timeout period.
'JCAM_DLL_API int STDCALL jsReadMultipleProfilesTimeout(JCONNECTION const jc, jsProfile * const profiles, UINT32 cProfiles, long timeoutMilliseconds);
Declare Function jsReadMultipleProfilesTimeout Lib "jcam_dll.dll" (ByVal jc As Long, ByRef profile As jsProfile, ByVal cProfiles As Long, ByVal timeoutMilliseconds As Long) As Long

' \ingroup synchronizedScanning
' \brief Returns the number of unread requests from either \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest().
'
' Returns the number of unread requests generated by either \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest().
' This function does not differentiate between requests generated by \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest().<br>
'
' The number of profiles generated by \c #jsSendMultipleProfileRequest() may be higher than the number of outstanding requests since more than one profile could be returned by one request.
'
' Any further calls to \c #jsReadProfileN() or \c #jsReadMultipleProfiles() will block unless a new call to \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest() is made.
'
' \see \c #jsCleanUpOutstandingRequests()
' \see \c #jsSendProfileRequestN()
' \see \c #jsReadProfileN()
' \see \c #jsSendMultipleProfileRequest()
' \see \c #jsReadMultipleProfiles()
'
' \param jc The connection to ask how many unread responses there are.
'
' \return The number of unread responses from either \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest().
'JCAM_DLL_API size_t STDCALL jsGetNumberOfOutstandingRequests(JCONNECTION const jc);
Declare Function jsGetNumberOfOutstandingRequests Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup synchronizedScanning
' \brief Reads and discards all the profiles in the TCP/IP stack generated by \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest().
'
' Reads any outstanding responses to \c #jsSendProfileRequestN() or \c #jsSendMultipleProfileRequest() calls.
'
' \see \c #jsGetNumberOfOutstandingRequests()
' \see \c #jsSendProfileRequestN()
' \see \c #jsReadProfileN()
' \see \c #jsSendMultipleProfileRequest()
' \see \c #jsReadMultipleProfiles()
'
' \param jc The connection to discard unread profiles from.
'
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsCleanUpOutstandingRequests(JCONNECTION const jc);
Declare Function jsCleanUpOutstandingRequests Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup parameters
' \brief Sends a parameter file to the scanhead.
' If OPERATION_FAILURE is returned, the error messages should be checked
' using jsGetNumberOfErrorMessages() and jsGetErrorMessage().  The error
' messages are stored inside the opaque \c #JCONNECTION.
' \param jc The connection to the scanner.
' \param filename The name of the file to send to the scanner.
' \return 0 on success.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #OPERATION_FAILURE on all other failures, including parse and file I/O errors.
'JCAM_DLL_API int STDCALL jsSendParameterFileToScanner(JCONNECTION const jc, char const * const filename);
Declare Function jsSendParameterFileToScanner Lib "jcam_dll.dll" (ByVal jc As Long, ByVal filename As String) As Long


' \ingroup parameters
' \brief Sends parameters to the scanhead.
' If \c #OPERATION_FAILURE is returned, the error messages should be checked
' using \c jsGetNumberOfErrorMessages() and \c jsGetErrorMessage().  The error
' messages are stored inside the opaque \c #JCONNECTION.
' \see \c #jsGetErrorMessage()
' \see \c #jsGetNumberOfErrorMessages() 
' \see \c #jsSendParameterFileToScanner()
' \see \c #jsGetParameterFileFromScanner()
' \param jc The connection to the scanner.
' \param parameters A NULL-terminated string with the parameters to send to the scanner.
' \return 0 on success.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #INVALID_PARAMETER if \c jc or \c parameters is \c NULL.
' \return \c #OPERATION_FAILURE on all other failures, including parse and file I/O errors.
'JCAM_DLL_API int STDCALL jsSendParametersToScanner(JCONNECTION const jc, char const * const parameters);
Declare Function jsSendParametersToScanner Lib "jcam_dll.dll" (ByVal jc As Long, ByVal filename As String) As Long

' \ingroup parameters
' \brief Reads the current parameter file from the scanhead and writes them to the specified file.
' \param jc the connection to the scanner.
' \param filename The name of the file to save the parameters in.  The file will be created if it doesn't exist.
' \return 0 on success.
' \return \c #SCANNER_FAILURE on all connection failures.
' \return \c #OPERATION_FAILURE on all other failures.
'JCAM_DLL_API int STDCALL jsGetParameterFileFromScanner(JCONNECTION const jc, char const * const filename);
Declare Function jsGetParameterFileFromScanner Lib "jcam_dll.dll" (ByVal jc As Long, ByVal filename As String) As Long

' \ingroup parameters
' \brief Returns the number of error messages after a
' jsSendParameterFileToScanner() call returned \c #OPERATION_FAILURE.
' \return The number of error messages.
' \return 0 if \c jc is \c NULL.
'JCAM_DLL_API size_t STDCALL jsGetNumberOfErrorMessages(JCONNECTION const jc);
Declare Function jsGetNumberOfErrorMessages Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup parameters
' \brief Returns the specified error message.
' Do not modify the returned string.
' \param jc The connection to the scanner.
' \param i The index of the error message to retrieve.
' \return A C string of the error message.
' \return \c NULL if \c i is out of range or \c jc is \c NULL.
'JCAM_DLL_API char const * const STDCALL jsGetErrorMessage(JCONNECTION const jc, size_t i);
'TODO figure out how to return a string from a DLL
'Declare Function jsGetErrorMessage Lib "jcam_dll.dll" (ByVal jc As Long, ByVal i As Long) As Byte()


' \ingroup scannerConfiguration
' \brief Reads the current position calibration for the selected laser from the scanner.
' \see \c #jsSendPositionCalibrationN()
' \param jc The connection to the scanner.
' \param laserIndex Which laser to read the position calibration for.
' \param xOffset Stores the value of the scanner's x offset.
' \param yOffset Stores the value of the scanner's y offset.
' \param roll Stores the value of the scanner's rotation.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc, \c xOffset, \c yOffset, or \c roll is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsReadPositionCalibrationN(JCONNECTION const jc, jsLaserIndex const laserIndex, double *xOffset, double *yOffset, double *roll);
Declare Function jsReadPositionCalibrationN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long, ByRef xOffset As Double, ByRef yOffset As Double, ByRef roll As Double) As Long

' \ingroup scannerConfiguration
' \brief Sends a position calibration for the selected laser to the scanner.
' \see \c #jsReadPositionCalibrationN()
' \param jc The connection to the scanner.
' \param laserIndex Which laser to send the position calibration for.
' \param xOffset The new value of the scanner's x offset.
' \param yOffset The new value of the scanner's y offset.
' \param roll The new value of the scanner's rotation.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE on all connection failures.
'JCAM_DLL_API int STDCALL jsSendPositionCalibrationN(JCONNECTION const jc, jsLaserIndex const laserIndex, double const xOffset, double const yOffset, double const roll);
Declare Function jsSendPositionCalibrationN Lib "jcam_dll.dll" (ByVal jc As Long, ByVal laserIndex As Long, ByVal xOffset As Double, ByVal yOffset As Double, ByVal roll As Double) As Long

' \ingroup statusFunctions
' \brief Reads status from the scanner into a data structure inside the opaque \c #JCONNECTION.
' \param jc The connection to the scanner.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc is \c NULL.
' \return \c #SCANNER_FAILURE if the connection closes.
'JCAM_DLL_API int STDCALL jsGetScannerStatusFromScanner(JCONNECTION const jc);
Declare Function jsGetScannerStatusFromScanner Lib "jcam_dll.dll" (ByVal jc As Long) As Long

' \ingroup statusFunctions
' \brief Gets the specified status value from the data structure inside the \c #JCONNECTION.
' \param jc The connection to the scanner.
' \param i The index of the status value to retrieve.
' \param value Pointer to an int that will hold the value.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c value is \c NULL, or if \c i is out of range.
'JCAM_DLL_API int STDCALL jsGetScannerStatusValue(JCONNECTION const jc, size_t i, int *value);
Declare Function jsGetScannerStatusValue Lib "jcam_dll.dll" (ByVal jc As Long, ByVal i As Long, ByRef value As Long) As Long

' \ingroup statusFunctions
' \brief Reads a descriptive text string from the scanner for the particular status index.
' The description length should be a minimum of 128 characters.
' After this call, \c description will be properly null-terminated.
' If \c description isn't long enough, the result will be truncated, but still properly null-terminated.
' The first valid index is 0, the last valid index is 12.
' Invalid indexes will return the string "ERROR unsuported status type".
' \param jc The connection to the scanner.
' \param i The index of the status name to retrieve.
' \param description The character buffer that will contain the status name.
' \param description_length The number of characters that \c description points to.
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c jc or \c description is \c NULL, or if \c i is out of range.
' \return \c #SCANNER_FAILURE if the connection closes.
'JCAM_DLL_API int STDCALL jsGetStatusDescriptionFromScanner(JCONNECTION const jc, UINT32 i, char * const description, UINT32 description_length);
Declare Function jsGetStatusDescriptionFromScanner Lib "jcam_dll.dll" (ByVal jc As Long, ByVal i As Long, ByVal description As String, ByVal description_length As Long) As Long

' \ingroup scanAndImage
' \brief Returns a pixel value from an image.
' This function checks to ensure that \c image isn't \c NULL, but doesn't do
' any error checking to ensure that \c x and \c y are within bounds.<BR>
' <CODE>(0, 0)</CODE> is the upper-left pixel.
' <CODE>(image->numberHorizontal - 1, image->numberVertical - 1)</CODE> is the lower-right pixel.
' \param image The image to get a pixel value from.
' \param x The x coordinate of the pixel to get.
' \param y The y coordinate of the pixel to get.
' \return The greyscale pixel value in the range of 0 to 255.
' \return 0 if \c image is \c NULL.
'JCAM_DLL_API int STDCALL jsGetImagePixel(jsImage const * const image, size_t const x, size_t const y);
'TODO Can't use jsImage...it's too big
'Declare Function jsGetImagePixel Lib "jcam_dll.dll" (ByRef jsImage As jsImage, ByVal x As Long, ByVal y As Long) As Long

' \ingroup scannerDiscovery
' \brief Attempts to discover all scanners on the network.
' Up to \c nResponses from the scanners will be stored in \c responses.<BR>
' Blocks for approximately one second while waiting for responses from the scanners.
' \param responses An array for holding responses from the scanners on the network.
' \param nResponses The number of elements in \c responses.
' \return The number of responses on success.
' \return -1 on all failures.
'TODO Can we pass jsResponses as an array?
'JCAM_DLL_API int STDCALL jsFindAllScanners(jsResponsePacket responses[], const size_t nResponses);
Declare Function jsFindAllScannersVB Lib "jcam_dll.dll" (ByRef responses() As jsResponsePacket) As Long

' \ingroup scannerDiscovery
' \brief Attempts to discover the scanner(s) on the network with the specified Cable ID.
' If there is more than one scanner with the same Cable ID, they will both respond.<BR>
' Up to \c nResponses from the scanners will be stored in \c responses.<BR>
' Blocks for approximately one second while waiting for responses from the scanners.
' \param cableId the cable ID of the scanner(s) you want to discover.
' \param responses An array for holding responses from the scanners on the network.
' \param nResponses The number of elements in \c responses.
' \return The number of responses on success.
' \return -1 on all failures.
'TODO Can we pass jsResponses as an array?
'JCAM_DLL_API int STDCALL jsFindScannerByCableId(int const cableId, jsResponsePacket responses[], const size_t nResponses);
Declare Function jsFindScannerByCableIdVB Lib "jcam_dll.dll" (ByVal cableId As Long, ByRef responses As jsResponsePacket) As Long

' \ingroup scannerDiscovery
' \brief Attempts to discover the scanner on the network with the specified serial number.
' Since serial numbers are unique, there should only ever be one scanner responding to this search.<BR>
' Up to \c nResponses from the scanners will be stored in \c responses.<BR>
' Blocks for approximately one second while waiting for responses from the scanners.
' \param serialNumber the serial number of the scanner you want to discover.
' \param responses An array for holding responses from the scanners on the network.
' \param nResponses The number of elements in \c responses.
' \return The number of responses on success.
' \return -1 on all failures.
'TODO Can we pass jsResponses as an array?
'JCAM_DLL_API int STDCALL jsFindScannerBySerialNumber(int const serialNumber, jsResponsePacket responses[], const size_t nResponses);
Declare Function jsFindScannerBySerialNumberVB Lib "jcam_dll.dll" (ByVal serialNumber As Long, ByRef responses As jsResponsePacket) As Long

' \ingroup scannerDiscovery
' \brief Sets a scanner's static IP address.
'
' Sets a scanner's IP address.
' The IP address will be static; that is it will not depend on the Cable ID of the scanner.
' If the scanner is moved to a different location with a different Cable ID, it will have the same IP address.
'
' \param serialNumber The serial number of the scanner whose IP address you want to set.
' \param staticIpAddress <b>Must be in network byte order.</b> An integer representing the IP address the scanner will use.
' \param netmask <b>Must be in network byte order.</b> An integer representing the IP netmask the scanner will use.
'
' \return 0 on success.
' \return -1 on all failures.
'JCAM_DLL_API int STDCALL jsSetStaticIpInt(int const serialNumber, unsigned long const staticIpAddress, unsigned long const netmask);
Declare Function jsSetStaticIpInt Lib "jcam_dll.dll" (ByVal serialNumber As Long, ByVal staticIpAddress As Long, ByVal netmask As Long) As Long

' \ingroup scannerDiscovery
' \brief Sets a scanner's static IP address.
'
' Sets a scanner's IP address.
' The IP address will be static; that is it will not depend on the Cable ID of the scanner.
' If the scanner is moved to a different location with a different Cable ID, it will have the same IP address.
'
' \param serialNumber The serial number of the scanner whose IP address you want to set.
' \param staticIpAddress The IP address the scanner will use.
' \param netmask The IP netmask the scanner will use.
'
' \return 0 on success.
' \return -1 on all failures.
'JCAM_DLL_API int STDCALL jsSetStaticIpChar(int const serialNumber, char const * const staticIpAddress, char const * const netmask);
Declare Function jsSetStaticIpChar Lib "jcam_dll.dll" (ByVal serialNumber As Long, ByVal staticIpAddress As String, ByVal netmask As String) As Long

' \ingroup scannerDiscovery
' \brief Sets a scanner's base IP address.
'
' Sets a scanner's base IP address.
' The IP address will be determined by adding the scanner's Cable ID to the base IP address.
'
' \param serialNumber The serial number of the scanner whose IP address you want to set.
' \param baseIpAddress <b>Must be in network byte order.</b> An integer representing the base IP address the scanner will use to determine its final IP address.
' \param netmask <b>Must be in network byte order.</b> An integer representing the IP netmask the scanner will use.
'
' \return 0 on success.
' \return -1 on all failures.
'JCAM_DLL_API int STDCALL jsSetBaseIpInt(UINT32 const serialNumber, UINT32 const baseIpAddress, UINT32 const netmask);
Declare Function jsSetBaseIpInt Lib "jcam_dll.dll" (ByVal serialNumber As Long, ByVal baseIpAddress As Long, ByVal netmask As Long) As Long

' \ingroup scannerDiscovery
' \brief Sets a scanner's static IP address.
'
' Sets a scanner's base IP address.
' The IP address will be determined by adding the scanner's Cable ID to the base IP address.
'
' \param serialNumber The serial number of the scanner whose IP address you want to set.
' \param baseIpAddress The base IP address the scanner will use to determine its final IP address.
' \param netmask The IP netmask the scanner will use.
'
' \return 0 on success.
' \return -1 on all failures.
'JCAM_DLL_API int STDCALL jsSetBaseIpChar(UINT32 const serialNumber, char const * const baseIpAddress, char const * const netmask);
Declare Function jsSetBaseIpChar Lib "jcam_dll.dll" (ByVal serialNumber As Long, ByVal baseIpAddress As String, ByVal netmask As String) As Long


' \ingroup scannerConfiguration
' \brief Overrides the cable ID physically wired into a scanner.
'
' The new cable ID is persistent.
' If the scanner is rebooted, it will ignore the physically wired in cable ID.
' If the scanner is set to use Base+IP addressing, the scanner's IP address will change according to the new IP address.
'
' \param serialNumber The serial number of the scanner to change.
' \param cableId The cable ID you wish the scanner to have.
'
' \return 0 on success.
' \return \c #INVALID_PARAMETER if \c cableId is over 31.
' \return -1 on all other failures.
'JCAM_DLL_API int STDCALL jsSetCableId(UINT32 const serialNumber, UINT32 const cableId);
Declare Function jsSetCableId Lib "jcam_dll.dll" (ByVal serialNumber As Long, ByVal cableId As Long) As Long


' \ingroup scannerConfiguration
' \brief Reverts to the cable ID physically wired into a scanner.
'
' If the scanner is set to use Base+IP addressing, the scanner's IP address will change according to the new IP address.
'
' \param serialNumber The serial number of the scanner to change.
'
' \return 0 on success.
' \return \c #INVALID_PARAMETER \c cableId is over 31.
' \return -1 on all other failures.
'JCAM_DLL_API int STDCALL jsClearCableId(UINT32 const serialNumber);
Declare Function jsClearCableId Lib "jcam_dll.dll" (ByVal serialNumber As Long) As Long
